## insighttoolkit4 4.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(WIN32 OR NOT EXISTS /dev/urandom)
  cmake_minimum_required(VERSION 2.8.5)
endif()

project(ITK)

if( WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK source code directory path length is too long (${n} > 50)."
      "Please move the ITK source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK build directory path length is too long (${n} > 50)."
      "Please set the ITK build directory to a directory with a shorter path."
      )
  endif()

endif()

set(CMAKE_MODULE_PATH ${ITK_SOURCE_DIR}/CMake ${CMAKE_MODULE_PATH})
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(ITKModuleMacros)
include(ITKExternalData)
include(itkCheckSourceTree)

set(main_project_name ${_ITKModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# ITK version number.
set(ITK_VERSION_MAJOR "4")
set(ITK_VERSION_MINOR "2")
set(ITK_VERSION_PATCH "1")

if(NOT ITK_INSTALL_RUNTIME_DIR)
  set(ITK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT ITK_INSTALL_LIBRARY_DIR)
  set(ITK_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT ITK_INSTALL_ARCHIVE_DIR)
  set(ITK_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT ITK_INSTALL_INCLUDE_DIR)
  set(ITK_INSTALL_INCLUDE_DIR include/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DATA_DIR)
  set(ITK_INSTALL_DATA_DIR share/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DOC_DIR)
  set(ITK_INSTALL_DOC_DIR share/doc/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_PACKAGE_DIR)
  set(ITK_INSTALL_PACKAGE_DIR "lib/cmake/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}")
endif()

# Override CMake's built-in add_* commands: assign LABELS to tests and targets
# automatically. Depends on the CMake variable itk-module being set to the
# "current" module when add_* is called.
macro(verify_itk_module_is_set)
  if("" STREQUAL "${itk-module}")
    message(FATAL_ERROR "CMake variable itk-module is not set")
  endif()
endmacro()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable runinng cppcheck for each module on its source and test directories.
option(ITK_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(ITK_CPPCHECK_TEST)

#-----------------------------------------------------------------------------
# Default values for CMake options may vary based on whether it's a
# dashboard build or not:
#
if("$ENV{DASHBOARD_TEST_FROM_CTEST}" STREQUAL "")
  # developer build
  set(ITK_BUILD_ALL_MODULES_DEFAULT ON)
  set(BUILD_EXAMPLES_DEFAULT ON)
else()
  # dashboard build
  set(ITK_BUILD_ALL_MODULES_DEFAULT ON)
  set(BUILD_EXAMPLES_DEFAULT ON)
endif()

#-----------------------------------------------------------------------------
# Enable the download and use of BrainWeb datasets.
# When this data is available, additional 3D tests are enabled.
option(ITK_USE_BRAINWEB_DATA "Download and use BrainWeb data for advanced testing" OFF)
mark_as_advanced(ITK_USE_BRAINWEB_DATA)

#-----------------------------------------------------------------------------
# ITK wrapper for add_test that automatically sets the test's LABELS property
# to the value of its containing module.
#
function(itk_add_test)
  # Add tests with data in the ITKData group.
  ExternalData_add_test(ITKData ${ARGN})

  if("NAME" STREQUAL "${ARGV0}")
    set(_iat_testname ${ARGV1})
  else()
    set(_iat_testname ${ARGV0})
  endif()

  if(itk-module)
    set(_label ${itk-module})
    if(TARGET ${itk-module}-all AND "${ARGN}" MATCHES "DATA{")
      add_dependencies(${itk-module}-all ITKData)
    endif()
  else()
    set(_label ${main_project_name})
  endif()

  set_property(TEST ${_iat_testname} PROPERTY LABELS ${_label})
endfunction()

#-----------------------------------------------------------------------------
# ITK build configuration options.
option(BUILD_SHARED_LIBS "Build ITK with shared libraries." OFF)
set(ITK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

include(ITKSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for ITK
include(itkTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ITK_REQUIRED_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ITK_REQUIRED_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
set(ITK_MODULES_DIR "${ITK_BINARY_DIR}/${ITK_INSTALL_PACKAGE_DIR}/Modules")


#-----------------------------------------------------------------------------
# Provide compatibility options.
option(ITKV3_COMPATIBILITY "Enable compatibility with ITK3.x when possible." OFF)
option(ITK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(ITK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(ITK_LEGACY_REMOVE ITK_LEGACY_SILENT ITK_V3_COMPATIBILITY)

#-----------------------------------------------------------------------------
# ITK build classes that are in the review process
option(ITK_USE_REVIEW "Build algorithms that are candidates to be included in the Toolkit. This classes are not covered by the Backward Compatibility Policy, no
r the Copyright Policy of ITK." OFF)
mark_as_advanced(ITK_USE_REVIEW)

if (ITK_USE_REVIEW)
  set(Module_ITKReview ON)
endif(ITK_USE_REVIEW)

#-----------------------------------------------------------------------------
# ITK uses KWStyle for checking the coding style
INCLUDE(${ITK_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# ITK build the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory."
  ${BUILD_EXAMPLES_DEFAULT})

#-----------------------------------------------------------------------------
# Enable GPU support. Requires OpenCL to be installed
option(ITK_USE_GPU "GPU acceleration via OpenCL" OFF)
mark_as_advanced(ITK_USE_GPU)

if( ITK_USE_GPU )
   include(itkOpenCL)
endif( ITK_USE_GPU )

#-----------------------------------------------------------------------------
# Manage FFT v3 Options
#
# USE_FFTWD -- use double precision fftw
option(USE_FFTWD "Use double precision fftw if found" OFF)
mark_as_advanced(USE_FFTWD)
#
# USE_FFTWF -- use single precision fftw
option(USE_FFTWF "Use single precision fftw if found" OFF)
mark_as_advanced(USE_FFTWF)

# USE_SYSTEM_FFTW -- locate a readybuilt fftw installation
option(USE_SYSTEM_FFTW "Use an installed version of fftw" OFF)
mark_as_advanced(USE_SYSTEM_FFTW)

if( USE_FFTWD OR USE_FFTWF )
  #
  # use ExternalProject
  include(ExternalProject)

  include(itkExternal_FFTW)
endif( USE_FFTWD OR USE_FFTWF )

if(NOT ITKV3_COMPATIBILITY)
  option(ITK_USE_64BITS_IDS "When ON, ITK will use 64 bits integers to index pixels. This is needed for managing images larger than 4Gb in some platforms." OFF)
  mark_as_advanced(ITK_USE_64BITS_IDS)
endif()

# ITK turn on concept checking
option(ITK_USE_CONCEPT_CHECKING "Turn on concept checking to give helpful errors at compile time if a type cannot be used as a template parameter." ON)
mark_as_advanced(ITK_USE_CONCEPT_CHECKING)
option(ITK_USE_STRICT_CONCEPT_CHECKING "Turn on Strict concept checking to give more stringent errors at compile time if a type cannot be used as a template parameter." OFF)
mark_as_advanced(ITK_USE_STRICT_CONCEPT_CHECKING)

#----------------------------------------------------------------------------
set(ITK_TEST_OUTPUT_DIR "${ITK_BINARY_DIR}/Testing/Temporary")

# Configure the default ITK_DATA_ROOT for the location of ITK Data.
set(ITK_DATA_ROOT ${ITK_SOURCE_DIR}/Testing/Data)

# Location of ITK Example Data.
set(ITK_EXAMPLE_DATA_ROOT "${ITK_SOURCE_DIR}/Examples/Data")

#This flag is used in particular, to enable some tests that require large memory to run.
# This probably can be discovered at configuration time by CMake. (Check with CMake developers).
set(ITK_COMPUTER_MEMORY_SIZE 1 CACHE STRING "Provide here the size of your RAM Memory in GigaBytes")
mark_as_advanced(ITK_COMPUTER_MEMORY_SIZE)




#----------------------------------------------------------------------
# Load the module DAG.
set(ITK_MODULES_ALL)
file(GLOB meta RELATIVE "${ITK_SOURCE_DIR}"
   "${ITK_SOURCE_DIR}/*/*/*/itk-module.cmake" # grouped modules
  )
foreach(f ${meta})
  include(${ITK_SOURCE_DIR}/${f})
  list(APPEND ITK_MODULES_ALL ${itk-module})
  get_filename_component(${itk-module}_BASE ${f} PATH)
  set(${itk-module}_SOURCE_DIR ${ITK_SOURCE_DIR}/${${itk-module}_BASE})
  set(${itk-module}_BINARY_DIR ${ITK_BINARY_DIR}/${${itk-module}_BASE})
  if(BUILD_TESTING AND EXISTS ${${itk-module}_SOURCE_DIR}/test)
    list(APPEND ITK_MODULES_ALL ${itk-module-test})
    set(${itk-module-test}_SOURCE_DIR ${${itk-module}_SOURCE_DIR}/test)
    set(${itk-module-test}_BINARY_DIR ${${itk-module}_BINARY_DIR}/test)
    set(${itk-module-test}_IS_TEST 1)
    set(${itk-module}_TESTED_BY ${itk-module-test})
    set(${itk-module-test}_TESTS_FOR ${itk-module})
  endif()

  # Reject bad dependencies.
  string(REGEX MATCHALL ";(ITKDeprecated|ITKReview|ITKIntegratedTest);"
    _bad_deps ";${ITK_MODULE_${itk-module}_DEPENDS};${ITK_MODULE_${itk-module-test}_DEPENDS};")
  foreach(dep ${_bad_deps})
    if(NOT "${itk-module}" MATCHES "^(${dep}|ITKIntegratedTest)$")
      message(FATAL_ERROR
        "Module \"${itk-module}\" loaded from\n"
        "  ${${itk-module}_BASE}/itk-module.cmake\n"
        "may not depend on module \"${dep}\".")
    endif()
  endforeach()
endforeach()
# Clear variables set later in each module.
unset(itk-module)
unset(itk-module-test)

# Validate the module DAG.
macro(itk_module_check itk-module _needed_by stack)
  if(NOT ITK_MODULE_${itk-module}_DECLARED)
    message(FATAL_ERROR "No such module \"${itk-module}\" needed by \"${_needed_by}\"")
  endif()
  if(check_started_${itk-module} AND NOT check_finished_${itk-module})
    # We reached a module while traversing its own dependencies recursively.
    set(msg "")
    foreach(entry ${stack})
      set(msg " ${entry} =>${msg}")
      if("${entry}" STREQUAL "${itk-module}")
        break()
      endif()
    endforeach()
    message(FATAL_ERROR "Module dependency cycle detected:\n ${msg} ${itk-module}")
  elseif(NOT check_started_${itk-module})
    # Traverse dependencies of this module.  Mark the start and finish.
    set(check_started_${itk-module} 1)
    foreach(dep IN LISTS ITK_MODULE_${itk-module}_DEPENDS)
      itk_module_check(${dep} ${itk-module} "${itk-module};${stack}")
    endforeach()
    set(check_finished_${itk-module} 1)
  endif()
endmacro()

foreach(itk-module ${ITK_MODULES_ALL})
  itk_module_check("${itk-module}" "" "")
endforeach()

=== Examples/CMakeLists.txt ===
if(NOT ITK_BUILD_ALL_MODULES)
  message(FATAL_ERROR "BUILD_EXAMPLES requires ITK_BUILD_ALL_MODULES")
endif()

find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

set(ITK_TEST_DRIVER itkTestDriver)

add_subdirectory(Iterators)
add_subdirectory(DataRepresentation)
add_subdirectory(Filtering)
add_subdirectory(IO)
add_subdirectory(Numerics)
add_subdirectory(Registration)
add_subdirectory(Segmentation)
add_subdirectory(SpatialObjects)
add_subdirectory(Statistics)

=== Wrapping/CMakeLists.txt ===
#==========================================================================
#
#   Copyright Insight Software Consortium
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#          http://www.apache.org/licenses/LICENSE-2.0.txt
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
#==========================================================================*/

project(WrapITK)

# set an internal cache to mark when this file is parsed
set(ITK_WRAPPING_REACHED ON CACHE INTERNAL "Wrapping folder has been reached")

# check cmake version
# Require 2.4.2 for MATH and LIST commands (REMOVE_ITEM is not the same in
# 2.4.1)
# 2.4.5 is required to parse the if(POLICY) command.
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
  if(POLICY CMP0011)
    cmake_policy(SET CMP0011 NEW)
  endif(POLICY CMP0011)

endif(COMMAND CMAKE_POLICY)
include("CMakeUtilityFunctions.cmake")

set(ITK_VERSION "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}.${ITK_VERSION_PATCH}")
if(NOT "${CMAKE_VERSION}" STRLESS "2.6.3")
  cmake_policy(SET CMP0011 OLD)
endif(NOT "${CMAKE_VERSION}" STRLESS "2.6.3")

enable_testing()
# include(CTest)
# if(BUILD_TESTING)
#   set(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
#   mark_as_advanced(BUILDNAME)
# endif(BUILD_TESTING)

###############################################################################
# Config ITKWrap
###############################################################################

# Set up options needed for ConfigureWrapping

# set WrapITK version
set(WrapITK_VERSION_MAJOR 0)
set(WrapITK_VERSION_MINOR 4)
set(WrapITK_VERSION_PATCH 0)


option(ITK_WRAP_unsigned_char "Wrap unsigned char type" ON)
option(ITK_WRAP_unsigned_short "Wrap unsigned short type" OFF)
option(ITK_WRAP_unsigned_long "Wrap unsigned long type" OFF)

option(ITK_WRAP_signed_char "Wrap signed char type" OFF)
option(ITK_WRAP_signed_short "Wrap signed short type" ON)
option(ITK_WRAP_signed_long "Wrap signed long type" OFF)

option(ITK_WRAP_float "Wrap float type" ON)
option(ITK_WRAP_double "Wrap double type" OFF)

option(ITK_WRAP_vector_float "Wrap vector float type" ON)
option(ITK_WRAP_vector_double "Wrap vector double type" OFF)

option(ITK_WRAP_covariant_vector_float "Wrap covariant vector float type" ON)
option(ITK_WRAP_covariant_vector_double "Wrap covariant vector double type" OFF)

option(ITK_WRAP_rgb_unsigned_char "Wrap RGB< unsigned char > type" ON)
option(ITK_WRAP_rgb_unsigned_short "Wrap RGB< unsigned short > type" OFF)

option(ITK_WRAP_rgba_unsigned_char "Wrap RGBA< unsigned char > type" ON)
option(ITK_WRAP_rgba_unsigned_short "Wrap RGBA< unsigned short > type" OFF)

option(ITK_WRAP_complex_float "Wrap complex<float> type" ON)
option(ITK_WRAP_complex_double "Wrap complex<double> type" OFF)

set(ITK_WRAP_DIMS "2;3" CACHE STRING "dimensions available separated by semicolons (;)")

option(INSTALL_WRAP_ITK_COMPATIBILITY "Install FindWrapITK.cmake and WrapITK.pth (so cmake and python can find WrapITK) as part of the standard installation process. This requires admin privileges. These files can be separately installed by making the install_wrapitk_compatibility target. " ON)

if(ITK_INSTALL_PACKAGE_DIR)
  string(REGEX REPLACE "^/" "" path "${ITK_INSTALL_PACKAGE_DIR}/WrapITK/")
else()
  set(path "lib/InsightToolkit/WrapITK/")
endif()
set(WRAP_ITK_INSTALL_PREFIX "${path}" CACHE INTERNAL "subpath where where most of WrapITK files will be installed")

# Output directories.
set(WRAP_ITK_CONFIG_DIR "${WrapITK_SOURCE_DIR}/")
set(WRAP_ITK_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(ITK_WRAP_JAVA_DIR "${WrapITK_BINARY_DIR}/Java")

if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${WrapITK_BINARY_DIR}/lib CACHE INTERNAL "Single output directory for building all libraries.")
endif(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)

if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH ${WrapITK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
endif(NOT EXECUTABLE_OUTPUT_PATH)

mark_as_advanced(CMAKE_LIBRARY_OUTPUT_DIRECTORY EXECUTABLE_OUTPUT_PATH WRAP_ITK_INSTALL_PREFIX)

set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

###############################################################################
# Additional files for installation
###############################################################################

install(FILES
  CMakeUtilityFunctions.cmake
  ConfigureWrapping.cmake
  TypedefMacros.cmake
  WrapBasicTypes.cmake
  WrapITKTypes.cmake
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/Configuration"
)

install(FILES "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/"
)

# Add a custom target to drive installation of the WrapITK-compatibility files
if(INSTALL_WRAP_ITK_COMPATIBILITY)
  # if we should by default install the files, make a custom target that will
  # always be built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility DEFAULT
    "Installing WrapITK compatibility files. Requires admin priviliges: turn off INSTALL_WRAP_ITK_COMPATIBILITY in cmake to disable.")
else(INSTALL_WRAP_ITK_COMPATIBILITY)
  # otherwise, add a target that will install the files only when that target is
  # manually built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility ON_DEMAND
    "Installing WrapITK compatibility files. Requires admin priviliges.")
endif(INSTALL_WRAP_ITK_COMPATIBILITY)

INSTALL_AT_ABSOLUTE_PATH(install_wrapitk_compatibility "${CMAKE_ROOT}/Modules" "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake")

set(WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(WRAP_ITK_LIB_DIRECTORY  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

###############################################################################
# Setup test driver
###############################################################################

set(ITK_TEST_DRIVER "itkTestDriver")

###############################################################################
# The real work on wrappers
###############################################################################

include(ConfigureWrapping.cmake)

###############################################################################
# let the different generators running some code before begining to parse the
# modules
###############################################################################

itk_wrap_modules()

###############################################################################
# Configure specific wrapper modules
###############################################################################

add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Modules" "${CMAKE_CURRENT_BINARY_DIR}/Modules")


###############################################################################
# let the different generators running some code after have parsed all the
# modules
###############################################################################

itk_end_wrap_modules()

###############################################################################
# Configure WrapITKConfig.cmake and FindWrapITK.cmake for external projects
###############################################################################
# First, configure for use directly from the build dir.
# we must add the options for the generators for the build dir case, so the
# external project won't find all the generators, even the usued ones.
# In the installed case, this feature is useful to let the packagers make several
# subpackages for wrapitk.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
foreach(lang ${WRAP_ITK_GENERATORS} ${WRAP_ITK_UNUSED_GENERATORS})
  string(TOUPPER "${lang}" lang_upper)
  set(CONFIG_WRAP_ITK_MORE_OPTIONS "${CONFIG_WRAP_ITK_MORE_OPTIONS}set(WRAP_ITK_${lang_upper} ${WRAP_ITK_${lang_upper}} CACHE BOOL \"Build swig ${lang} wrapper support.\")\n")
endforeach(lang)
set(CONFIG_CONFIG_DIR "${WrapITK_SOURCE_DIR}/ConfigurationInputs")
set(CONFIG_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
set(CONFIG_WRAP_ITK_MODULES "${WRAP_ITK_MODULES}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "${WrapITK_BINARY_DIR}/Python/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_WRAP_ITK_LIB_DIR  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/WrapITKConfig.cmake"
               @ONLY IMMEDIATE)

set(CONFIG_WRAP_ITK_DIR "${WrapITK_BINARY_DIR}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/FindWrapITK.cmake"
               @ONLY IMMEDIATE)

# Second, configure for installed use. Ensure that no absolute paths
# go into the installed config file, so that it is as portable as possible.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
set(CONFIG_CONFIG_DIR "\${WrapITK_DIR}/Configuration/Inputs")
set(CONFIG_CMAKE_DIR "\${WrapITK_DIR}/Configuration")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "\${WrapITK_DIR}/Configuration/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "\${WrapITK_DIR}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "\${WrapITK_DIR}/Python/")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "\${WrapITK_DIR}/lib")
set(CONFIG_WRAP_ITK_LIB_DIR  "\${WrapITK_DIR}/lib")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
               @ONLY IMMEDIATE)

set(CONFIG_WRAP_ITK_DIR "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake"
               @ONLY IMMEDIATE)

=== Examples/IO/CMakeLists.txt ===
project(IOExamples)

add_executable(ImageReadWrite ImageReadWrite.cxx )
target_link_libraries(ImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadCastWrite ImageReadCastWrite.cxx )
target_link_libraries(ImageReadCastWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExtractFilterInsertWrite ImageReadExtractFilterInsertWrite.cxx )
target_link_libraries(ImageReadExtractFilterInsertWrite  ${ITK_LIBRARIES})

add_executable(ImageReadRegionOfInterestWrite ImageReadRegionOfInterestWrite.cxx )
target_link_libraries(ImageReadRegionOfInterestWrite  ${ITK_LIBRARIES})

add_executable(RGBImageReadWrite RGBImageReadWrite.cxx )
target_link_libraries(RGBImageReadWrite  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageRead CovariantVectorImageRead.cxx )
target_link_libraries(CovariantVectorImageRead  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageExtractComponent CovariantVectorImageExtractComponent.cxx )
target_link_libraries(CovariantVectorImageExtractComponent  ${ITK_LIBRARIES})

add_executable(VectorImageReadWrite VectorImageReadWrite.cxx )
target_link_libraries(VectorImageReadWrite  ${ITK_LIBRARIES})

add_executable(ComplexImageReadWrite ComplexImageReadWrite.cxx )
target_link_libraries(ComplexImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExportVTK ImageReadExportVTK.cxx )
target_link_libraries(ImageReadExportVTK  ${ITK_LIBRARIES})

add_executable(RGBImageSeriesReadWrite RGBImageSeriesReadWrite.cxx )
target_link_libraries(RGBImageSeriesReadWrite  ${ITK_LIBRARIES})

add_executable(ImageSeriesReadWrite ImageSeriesReadWrite.cxx )
target_link_libraries(ImageSeriesReadWrite  ${ITK_LIBRARIES})

add_executable(ImageSeriesReadWrite2 ImageSeriesReadWrite2.cxx )
target_link_libraries(ImageSeriesReadWrite2  ${ITK_LIBRARIES})

add_executable(ImageReadImageSeriesWrite ImageReadImageSeriesWrite.cxx )
target_link_libraries(ImageReadImageSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadImageWrite2 DicomSeriesReadImageWrite2.cxx )
target_link_libraries(DicomSeriesReadImageWrite2  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadGaussianImageWrite DicomSeriesReadGaussianImageWrite.cxx )
target_link_libraries(DicomSeriesReadGaussianImageWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadPrintTags DicomSeriesReadPrintTags.cxx )
target_link_libraries(DicomSeriesReadPrintTags  ${ITK_LIBRARIES})

add_executable(DicomImageReadPrintTags DicomImageReadPrintTags.cxx )
target_link_libraries(DicomImageReadPrintTags  ${ITK_LIBRARIES})

add_executable(DicomImageReadWrite DicomImageReadWrite.cxx )
target_link_libraries(DicomImageReadWrite  ${ITK_LIBRARIES})

add_executable(ImageReadDicomSeriesWrite ImageReadDicomSeriesWrite.cxx )
target_link_libraries(ImageReadDicomSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomImageReadChangeHeaderWrite DicomImageReadChangeHeaderWrite.cxx )
target_link_libraries(DicomImageReadChangeHeaderWrite  ${ITK_LIBRARIES})

add_executable(DicomSeriesReadSeriesWrite DicomSeriesReadSeriesWrite.cxx )
target_link_libraries(DicomSeriesReadSeriesWrite  ${ITK_LIBRARIES})

add_executable(DicomPrintPatientInformation DicomPrintPatientInformation.cxx )
target_link_libraries(DicomPrintPatientInformation  ${ITK_LIBRARIES})

add_executable(TransformReadWrite TransformReadWrite.cxx )
target_link_libraries(TransformReadWrite  ${ITK_LIBRARIES})

add_executable(VisibleHumanStreamReadWrite  VisibleHumanStreamReadWrite.cxx )
target_link_libraries(VisibleHumanStreamReadWrite  ${ITK_LIBRARIES})

add_executable(VisibleHumanPasteWrite  VisibleHumanPasteWrite.cxx )
target_link_libraries(VisibleHumanPasteWrite  ${ITK_LIBRARIES})

add_executable(CovariantVectorImageWrite CovariantVectorImageWrite.cxx )
target_link_libraries(CovariantVectorImageWrite  ${ITK_LIBRARIES})

add_executable(ImageReadExtractWrite ImageReadExtractWrite.cxx )
target_link_libraries(ImageReadExtractWrite  ${ITK_LIBRARIES})

add_executable(ConvertAnalyzeFile ConvertAnalyzeFile.cxx)
target_link_libraries(ConvertAnalyzeFile ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

add_subdirectory(XML)

=== Examples/Installation/CMakeLists.txt ===
# This is the root ITK CMakeLists file.
cmake_minimum_required(VERSION 2.4)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND CMAKE_POLICY)


# This project is designed to be built outside the Insight source tree.
project(HelloWorld)

# Find ITK.
find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

add_executable(HelloWorld HelloWorld.cxx )

target_link_libraries(HelloWorld ${ITK_LIBRARIES})

=== Examples/Registration/CMakeLists.txt ===
project(ImageRegistration)
include_regular_expression("^.*$")

add_executable(ImageRegistration3 ImageRegistration3.cxx )
target_link_libraries(ImageRegistration3 ${ITK_LIBRARIES})

add_executable(ImageRegistration5 ImageRegistration5.cxx )
target_link_libraries(ImageRegistration5 ${ITK_LIBRARIES})

add_executable(ImageRegistration6 ImageRegistration6.cxx )
target_link_libraries(ImageRegistration6 ${ITK_LIBRARIES})

add_executable(ImageRegistration8 ImageRegistration8.cxx )
target_link_libraries(ImageRegistration8 ${ITK_LIBRARIES})

add_executable(ImageRegistration9 ImageRegistration9.cxx )
target_link_libraries(ImageRegistration9 ${ITK_LIBRARIES})

add_executable(ImageRegistration10 ImageRegistration10.cxx )
target_link_libraries(ImageRegistration10 ${ITK_LIBRARIES})

add_executable(DeformableRegistration4 DeformableRegistration4.cxx )
target_link_libraries(DeformableRegistration4 ${ITK_LIBRARIES})

add_executable(ImageRegistration4 ImageRegistration4.cxx )
target_link_libraries(ImageRegistration4 ${ITK_LIBRARIES})

add_executable(ImageRegistration7 ImageRegistration7.cxx )
target_link_libraries(ImageRegistration7 ${ITK_LIBRARIES})

add_executable(ImageRegistration11 ImageRegistration11.cxx )
target_link_libraries(ImageRegistration11 ${ITK_LIBRARIES})

add_executable(ImageRegistration12 ImageRegistration12.cxx )
target_link_libraries(ImageRegistration12 ${ITK_LIBRARIES})

add_executable(ImageRegistration13 ImageRegistration13.cxx )
target_link_libraries(ImageRegistration13 ${ITK_LIBRARIES})

add_executable(ImageRegistration14 ImageRegistration14.cxx )
target_link_libraries(ImageRegistration14 ${ITK_LIBRARIES})

add_executable(ImageRegistration15 ImageRegistration15.cxx )
target_link_libraries(ImageRegistration15 ${ITK_LIBRARIES})

add_executable(ImageRegistration16 ImageRegistration16.cxx )
target_link_libraries(ImageRegistration16 ${ITK_LIBRARIES})

add_executable(ImageRegistration18 ImageRegistration18.cxx )
target_link_libraries(ImageRegistration18 ${ITK_LIBRARIES})

add_executable(ImageRegistration19 ImageRegistration19.cxx )
target_link_libraries(ImageRegistration19 ${ITK_LIBRARIES})

add_executable(ImageRegistration20 ImageRegistration20.cxx )
target_link_libraries(ImageRegistration20 ${ITK_LIBRARIES})

add_executable(DeformableRegistration6 DeformableRegistration6.cxx )
target_link_libraries(DeformableRegistration6 ${ITK_LIBRARIES})

add_executable(DeformableRegistration7 DeformableRegistration7.cxx )
target_link_libraries(DeformableRegistration7 ${ITK_LIBRARIES})

add_executable(DeformableRegistration8 DeformableRegistration8.cxx )
target_link_libraries(DeformableRegistration8 ${ITK_LIBRARIES})

if( USE_FFTWD )
  add_executable(DeformableRegistration9 DeformableRegistration9.cxx )
  target_link_libraries(DeformableRegistration9 ${ITK_LIBRARIES})

  add_executable(DeformableRegistration10 DeformableRegistration10.cxx )
  target_link_libraries(DeformableRegistration10 ${ITK_LIBRARIES})
endif( USE_FFTWD )

add_executable(MultiResImageRegistration1 MultiResImageRegistration1.cxx )
target_link_libraries(MultiResImageRegistration1 ${ITK_LIBRARIES})

add_executable(MultiResImageRegistration2 MultiResImageRegistration2.cxx )
target_link_libraries(MultiResImageRegistration2 ${ITK_LIBRARIES})

add_executable(MultiResImageRegistration3 MultiResImageRegistration3.cxx )
target_link_libraries(MultiResImageRegistration3 ${ITK_LIBRARIES})

add_executable(DeformableRegistration1 DeformableRegistration1.cxx )
target_link_libraries(DeformableRegistration1 ${ITK_LIBRARIES})

add_executable(DeformableRegistration11 DeformableRegistration11.cxx )
target_link_libraries(DeformableRegistration11 ${ITK_LIBRARIES})

add_executable(DeformableRegistration2 DeformableRegistration2.cxx )
target_link_libraries(DeformableRegistration2 ${ITK_LIBRARIES})

add_executable(DeformableRegistration3 DeformableRegistration3.cxx )
target_link_libraries(DeformableRegistration3 ${ITK_LIBRARIES})

add_executable(DeformableRegistration5 DeformableRegistration5.cxx )
target_link_libraries(DeformableRegistration5 ${ITK_LIBRARIES})

add_executable(DeformableRegistration12 DeformableRegistration12.cxx )
target_link_libraries(DeformableRegistration12 ${ITK_LIBRARIES})

add_executable(DeformableRegistration13 DeformableRegistration13.cxx )
target_link_libraries(DeformableRegistration13 ${ITK_LIBRARIES})

add_executable(DeformableRegistration14 DeformableRegistration14.cxx )
target_link_libraries(DeformableRegistration14 ${ITK_LIBRARIES})

add_executable(ChangeInformationImageFilter ChangeInformationImageFilter.cxx )
target_link_libraries(ChangeInformationImageFilter ${ITK_LIBRARIES})

add_executable(DeformableRegistration15 DeformableRegistration15.cxx )
target_link_libraries(DeformableRegistration15 ${ITK_LIBRARIES})

add_executable(DeformableRegistration16 DeformableRegistration16.cxx )
target_link_libraries(DeformableRegistration16 ${ITK_LIBRARIES})

add_executable(DeformableRegistration17 DeformableRegistration17.cxx )
target_link_libraries(DeformableRegistration17 ${ITK_LIBRARIES})

add_executable(DisplacementFieldInitialization DisplacementFieldInitialization.cxx )
target_link_libraries(DisplacementFieldInitialization ${ITK_LIBRARIES})

add_executable(LandmarkWarping2 LandmarkWarping2.cxx )
target_link_libraries(LandmarkWarping2 ${ITK_LIBRARIES})

add_executable(BSplineWarping1 BSplineWarping1.cxx )
target_link_libraries(BSplineWarping1 ${ITK_LIBRARIES})

add_executable(BSplineWarping2 BSplineWarping2.cxx )
target_link_libraries(BSplineWarping2 ${ITK_LIBRARIES})

add_executable(ThinPlateSplineWarp ThinPlateSplineWarp.cxx )
target_link_libraries(ThinPlateSplineWarp ${ITK_LIBRARIES})

add_executable(ModelToImageRegistration1 ModelToImageRegistration1.cxx )
target_link_libraries(ModelToImageRegistration1 ${ITK_LIBRARIES})

add_executable(ModelToImageRegistration2 ModelToImageRegistration2.cxx )
target_link_libraries(ModelToImageRegistration2 ${ITK_LIBRARIES})

add_executable(ImageRegistration1 ImageRegistration1.cxx )
target_link_libraries(ImageRegistration1 ${ITK_LIBRARIES})

add_executable(ImageRegistration2 ImageRegistration2.cxx )
target_link_libraries(ImageRegistration2 ${ITK_LIBRARIES})

add_executable(ImageRegistration17 ImageRegistration17.cxx )
target_link_libraries(ImageRegistration17 ${ITK_LIBRARIES})

#TODO needs updating to new statistics  add_executable(ImageRegistrationHistogramPlotter ImageRegistrationHistogramPlotter.cxx )
#TODO needs updating to new statistics  target_link_libraries(ImageRegistrationHistogramPlotter ${ITK_LIBRARIES})

add_executable(MeanSquaresImageMetric1  MeanSquaresImageMetric1.cxx )
target_link_libraries(MeanSquaresImageMetric1 ${ITK_LIBRARIES})

if(ITKV3_COMPATIBILITY)
  add_executable(DeformationFieldJacobian DeformationFieldJacobian.cxx )
  target_link_libraries(DeformationFieldJacobian ${ITK_LIBRARIES})
endif()

add_executable(IterativeClosestPoint1   IterativeClosestPoint1.cxx )
target_link_libraries(IterativeClosestPoint1 ${ITK_LIBRARIES})

add_executable(IterativeClosestPoint2   IterativeClosestPoint2.cxx )
target_link_libraries(IterativeClosestPoint2 ${ITK_LIBRARIES})

add_executable(IterativeClosestPoint3   IterativeClosestPoint3.cxx )
target_link_libraries(IterativeClosestPoint3 ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/Statistics/CMakeLists.txt ===
project(StatisticsExamples)
include_regular_expression("^.*$")


add_executable(BayesianPluginClassifier BayesianPluginClassifier.cxx )
target_link_libraries(BayesianPluginClassifier ${ITK_LIBRARIES})

add_executable( BayesianClassifierInitializer BayesianClassifierInitializer.cxx )
target_link_libraries(BayesianClassifierInitializer ${ITK_LIBRARIES})

add_executable( BayesianClassifier BayesianClassifier.cxx )
target_link_libraries(BayesianClassifier ${ITK_LIBRARIES})

add_executable(EuclideanDistanceMetric EuclideanDistanceMetric.cxx )
target_link_libraries(EuclideanDistanceMetric ${ITK_LIBRARIES})

add_executable(ExpectationMaximizationMixtureModelEstimator ExpectationMaximizationMixtureModelEstimator.cxx )
target_link_libraries(ExpectationMaximizationMixtureModelEstimator ${ITK_LIBRARIES})

add_executable(GaussianMembershipFunction GaussianMembershipFunction.cxx )
target_link_libraries(GaussianMembershipFunction ${ITK_LIBRARIES})

add_executable(Histogram Histogram.cxx )
target_link_libraries(Histogram ${ITK_LIBRARIES})

add_executable(KdTree KdTree.cxx )
target_link_libraries(KdTree ${ITK_LIBRARIES})

add_executable(KdTreeBasedKMeansClustering KdTreeBasedKMeansClustering.cxx )
target_link_libraries(KdTreeBasedKMeansClustering ${ITK_LIBRARIES})

add_executable(ListSample ListSample.cxx )
target_link_libraries(ListSample ${ITK_LIBRARIES})

add_executable(SampleToHistogramFilter SampleToHistogramFilter.cxx )
target_link_libraries(SampleToHistogramFilter ${ITK_LIBRARIES})

add_executable(MaximumDecisionRule MaximumDecisionRule.cxx )
target_link_libraries(MaximumDecisionRule ${ITK_LIBRARIES})

add_executable(MaximumRatioDecisionRule MaximumRatioDecisionRule.cxx )
target_link_libraries(MaximumRatioDecisionRule ${ITK_LIBRARIES})

add_executable(MembershipSample MembershipSample.cxx )
target_link_libraries(MembershipSample ${ITK_LIBRARIES})

add_executable(MinimumDecisionRule MinimumDecisionRule.cxx )
target_link_libraries(MinimumDecisionRule ${ITK_LIBRARIES})
#
# At the moment, itkNeighborhoodSampler is incomplete, so this example
# can't be updated
#
#add_executable(NeighborhoodSampler NeighborhoodSampler.cxx )
#target_link_libraries(NeighborhoodSampler ${ITK_LIBRARIES})

add_executable(NormalVariateGenerator NormalVariateGenerator.cxx )
target_link_libraries(NormalVariateGenerator ${ITK_LIBRARIES})

add_executable(PointSetToListSampleAdaptor PointSetToListSampleAdaptor.cxx )
target_link_libraries(PointSetToListSampleAdaptor ${ITK_LIBRARIES})

add_executable(SampleStatistics SampleStatistics.cxx )
target_link_libraries(SampleStatistics ${ITK_LIBRARIES})

add_executable(SampleSorting SampleSorting.cxx )
target_link_libraries(SampleSorting ${ITK_LIBRARIES})

add_executable(WeightedSampleStatistics WeightedSampleStatistics.cxx )
target_link_libraries(WeightedSampleStatistics ${ITK_LIBRARIES})

add_executable(ImageHistogram3 ImageHistogram3.cxx )
target_link_libraries(ImageHistogram3 ${ITK_LIBRARIES})

add_executable(ScalarImageMarkovRandomField1 ScalarImageMarkovRandomField1.cxx )
target_link_libraries(ScalarImageMarkovRandomField1 ${ITK_LIBRARIES})

add_executable(ScalarImageKmeansClassifier ScalarImageKmeansClassifier.cxx )
target_link_libraries(ScalarImageKmeansClassifier ${ITK_LIBRARIES})

add_executable(ImageToListSampleAdaptor ImageToListSampleAdaptor.cxx )
target_link_libraries(ImageToListSampleAdaptor ${ITK_LIBRARIES})

add_executable(ImageHistogram1 ImageHistogram1.cxx )
target_link_libraries(ImageHistogram1 ${ITK_LIBRARIES})

add_executable(ImageHistogram2 ImageHistogram2.cxx )
target_link_libraries(ImageHistogram2 ${ITK_LIBRARIES})

add_executable(ImageHistogram4 ImageHistogram4.cxx )
target_link_libraries(ImageHistogram4 ${ITK_LIBRARIES})

add_executable(ImageEntropy1 ImageEntropy1.cxx )
target_link_libraries(ImageEntropy1 ${ITK_LIBRARIES})

add_executable(ImageMutualInformation1 ImageMutualInformation1.cxx )
target_link_libraries(ImageMutualInformation1 ${ITK_LIBRARIES})

add_executable(ScalarImageKmeansModelEstimator ScalarImageKmeansModelEstimator.cxx )
target_link_libraries(ScalarImageKmeansModelEstimator ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Wrapping/Generators/CMakeLists.txt ===

###############################################################################
# the macros in charge of dispatching to the language specific macros

macro(itk_wrap_modules_all_generators)
#!  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
#!    INIT_itk_wrap_module_java()
#!  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)

  if(ITK_WRAP_PYTHON)
    itk_wrap_modules_python()
  endif(ITK_WRAP_PYTHON)
  if(ITK_WRAP_TCL)
    itk_wrap_modules_tcl()
  endif(ITK_WRAP_TCL)
  if(ITK_WRAP_JAVA)
    itk_wrap_modules_java()
  endif(ITK_WRAP_JAVA)
  if(ITK_WRAP_RUBY)
    itk_wrap_modules_ruby()
  endif(ITK_WRAP_RUBY)
endmacro(itk_wrap_modules_all_generators)

macro(itk_end_wrap_modules_all_generators)
  if(ITK_WRAP_PYTHON)
    itk_end_wrap_modules_python()
  endif(ITK_WRAP_PYTHON)
  if(ITK_WRAP_TCL)
    itk_end_wrap_modules_tcl()
  endif(ITK_WRAP_TCL)
  if(ITK_WRAP_JAVA)
    itk_end_wrap_modules_java()
  endif(ITK_WRAP_JAVA)
  if(ITK_WRAP_RUBY)
    itk_end_wrap_modules_ruby()
  endif(ITK_WRAP_RUBY)
endmacro(itk_end_wrap_modules_all_generators)


macro(itk_wrap_module_all_generators library_name)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_module_explicit("${library_name}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_module_gccxml("${library_name}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_module_swig_interface("${library_name}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_module_DOC("${library_name}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_module_python("${library_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_module_tcl("${library_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_module_ruby("${library_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_module_java("${library_name}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_module_all_generators)

macro(itk_end_wrap_module_all_generators)
  if(ITK_WRAP_EXPLICIT)
    itk_end_wrap_module_explicit()
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_end_wrap_module_gccxml()
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_end_wrap_module_swig_interface()
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_end_wrap_module_python()
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_end_wrap_module_tcl()
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_end_wrap_module_ruby()
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_end_wrap_module_java()
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
  if(ITK_WRAP_DOC)
    itk_end_wrap_module_DOC()
  endif(ITK_WRAP_DOC)
endmacro(itk_end_wrap_module_all_generators)


macro(itk_wrap_submodule_all_generators module)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_submodule_explicit("${module}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_submodule_gccxml("${module}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_submodule_swig_interface("${module}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_submodule_DOC("${module}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_submodule_python("${module}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_submodule_tcl("${module}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_submodule_ruby("${module}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_submodule_java("${module}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_submodule_all_generators)

macro(itk_end_wrap_submodule_all_generators module)
  if(ITK_WRAP_EXPLICIT)
    itk_end_wrap_submodule_explicit("${module}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_end_wrap_submodule_gccxml("${module}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_end_wrap_submodule_swig_interface("${module}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_end_wrap_submodule_python("${module}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_end_wrap_submodule_tcl("${module}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_end_wrap_submodule_ruby("${module}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_end_wrap_submodule_java("${module}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
  if(ITK_WRAP_DOC)
    itk_end_wrap_submodule_DOC()
  endif(ITK_WRAP_DOC)
endmacro(itk_end_wrap_submodule_all_generators)


macro(itk_wrap_class_all_generators class)
endmacro(itk_wrap_class_all_generators)

macro(itk_wrap_named_class_all_generators class swig_name)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_named_class_python("${class}" "${swig_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_named_class_tcl("${class}" "${swig_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_named_class_ruby("${class}" "${swig_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_DOC)
    itk_wrap_named_class_DOC("${class}" "${swig_name}")
  endif(ITK_WRAP_DOC)
endmacro(itk_wrap_named_class_all_generators class swig_name)

macro(itk_end_wrap_class_all_generators)
endmacro(itk_end_wrap_class_all_generators)


macro(itk_wrap_simple_class_all_generators class)
endmacro(itk_wrap_simple_class_all_generators class)


macro(itk_wrap_named_simple_class_all_generators class)
endmacro(itk_wrap_named_simple_class_all_generators class)


macro(itk_wrap_include_all_generators inc)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_include_explicit("${inc}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_include_gccxml("${inc}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_include_swig_interface("${inc}")
  endif(ITK_WRAP_SWIGINTERFACE)
endmacro(itk_wrap_include_all_generators inc)

macro(itk_wrap_template_all_generators name types)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_template_python("${name}" "${types}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_template_tcl("${name}" "${types}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_template_ruby("${name}" "${types}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
endmacro(itk_wrap_template_all_generators)


macro(itk_wrap_one_type_all_generators wrap_method wrap_class swig_name template_params)
  if(ITK_WRAP_EXPLICIT)
    itk_wrap_one_type_explicit("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_EXPLICIT)
  if(ITK_WRAP_GCCXML)
    itk_wrap_one_type_gccxml("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_SWIGINTERFACE)
    itk_wrap_one_type_swig_interface("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_SWIGINTERFACE)
  if(ITK_WRAP_DOC)
    itk_wrap_one_type_DOC("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_DOC)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_one_type_python("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_one_type_tcl("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_one_type_ruby("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_one_type_java("${wrap_method}" "${wrap_class}" "${swig_name}" "${template_params}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_one_type_all_generators)


macro(itk_wrap_simple_type_all_generators wrap_class swig_name)
  if(ITK_WRAP_GCCXML)
    itk_wrap_simple_type_gccxml("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_GCCXML)
  if(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
    itk_wrap_simple_type_python("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_PYTHON AND WRAPPER_LIBRARY_PYTHON)
  if(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
    itk_wrap_simple_type_tcl("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_TCL AND WRAPPER_LIBRARY_TCL)
  if(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
    itk_wrap_simple_type_ruby("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_RUBY AND WRAPPER_LIBRARY_RUBY)
  if(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
    itk_wrap_simple_type_java("${wrap_class}" "${swig_name}")
  endif(ITK_WRAP_JAVA AND WRAPPER_LIBRARY_JAVA)
endmacro(itk_wrap_simple_type_all_generators wrap_class swig_name)



###############################################################################
# ccache management. This option is shared by most of generators, so put it here.
option(ITK_USE_CCACHE "Use ccache to cache swig/gccxml/... output and speedup the rebuild." OFF)
mark_as_advanced(ITK_USE_CCACHE)
if(ITK_USE_CCACHE)
  find_program(CCACHE_EXECUTABLE NAMES ccache-swig ccache DOC "ccache executable.")
endif(ITK_USE_CCACHE)



###############################################################################
# build the generators list

if(EXTERNAL_WRAP_ITK_PROJECT)
  # generators there have been turned on while building wrapitk
  set(default ON)
else(EXTERNAL_WRAP_ITK_PROJECT)
  # set some of them to on by default
  option(ITK_WRAP_GCCXML "Build gccxml files." ON)
  option(ITK_WRAP_SWIGINTERFACE "Build swig interfaces." ON)
  set(default OFF)
endif(EXTERNAL_WRAP_ITK_PROJECT)

set(WRAP_ITK_GENERATORS CACHE INTERNAL "Internal generators list.")
set(WRAP_ITK_UNUSED_GENERATORS CACHE INTERNAL "Internal unused generators list.")
file(GLOB local_files *)
# filter and reorder the list
set(generators )
foreach(f ${local_files})
  file(RELATIVE_PATH lang "${CMAKE_CURRENT_SOURCE_DIR}" "${f}")
  if(IS_DIRECTORY "${f}")
    if("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
      # put those generators before the others
      set(generators ${lang} ${generators})
    else("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
      set(generators ${generators} ${lang})
    endif("${lang}" MATCHES "^GccXML$|^SwigInterface$|^Doc$")
  endif(IS_DIRECTORY "${f}")
endforeach(f)

foreach(lang ${generators})
  string(TOUPPER "${lang}" lang_upper)

  # add the language to the options
  option(ITK_WRAP_${lang_upper} "Build swig ${lang} wrapper support." ${default})

  # add the language to the list, if the user have turn it on, and include
  # the subdirectory
  if(ITK_WRAP_${lang_upper})
    set(WRAP_ITK_GENERATORS ${WRAP_ITK_GENERATORS} "${lang}")
    add_subdirectory("${lang}")
  else(ITK_WRAP_${lang_upper})
    set(WRAP_ITK_UNUSED_GENERATORS ${WRAP_ITK_UNUSED_GENERATORS} "${lang}")
  endif(ITK_WRAP_${lang_upper})
endforeach(lang)
set(WRAP_ITK_GENERATORS ${WRAP_ITK_GENERATORS} CACHE INTERNAL "Internal generators list.")
set(WRAP_ITK_UNUSED_GENERATORS ${WRAP_ITK_UNUSED_GENERATORS} CACHE INTERNAL "Internal unused generators list.")

# The include_directories are added here to be used by
# Wrapping/ConfigureWrapping.cmake
foreach(lang ${generators})
  string(TOUPPER "${lang}" lang_upper)
  if(ITK_WRAP_${lang_upper})

=== Examples/DataRepresentation/Image/CMakeLists.txt ===
project(ImageExamples)
include_regular_expression("^.*$")

add_executable(Image1 Image1.cxx )
target_link_libraries(Image1 ${ITK_LIBRARIES})

add_executable(Image2 Image2.cxx )
target_link_libraries(Image2 ${ITK_LIBRARIES})

add_executable(Image3 Image3.cxx )
target_link_libraries(Image3 ${ITK_LIBRARIES})

add_executable(Image4 Image4.cxx )
target_link_libraries(Image4 ${ITK_LIBRARIES})

add_executable(VectorImage VectorImage.cxx )
target_link_libraries(VectorImage ${ITK_LIBRARIES})

add_executable(ImageAdaptor2 ImageAdaptor2.cxx )
target_link_libraries(ImageAdaptor2 ${ITK_LIBRARIES})

add_executable(ImageAdaptor3 ImageAdaptor3.cxx )
target_link_libraries(ImageAdaptor3 ${ITK_LIBRARIES})

add_executable(ImageAdaptor4 ImageAdaptor4.cxx )
target_link_libraries(ImageAdaptor4 ${ITK_LIBRARIES})


add_executable(Image5 Image5.cxx )
target_link_libraries(Image5 ${ITK_LIBRARIES})

add_executable(ImageAdaptor1 ImageAdaptor1.cxx )
target_link_libraries(ImageAdaptor1 ${ITK_LIBRARIES})

add_executable(RGBImage RGBImage.cxx )
target_link_libraries(RGBImage ${ITK_LIBRARIES})



if(BUILD_TESTING)
  add_subdirectory(test)
endif(BUILD_TESTING)

=== Examples/Filtering/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Filtering)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

itk_add_test(NAME BilateralImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BilateralImageFilter.png}
            ${TEMP}/BilateralImageFilter.png
  $<TARGET_FILE:BilateralImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BilateralImageFilter.png
        6.0 5.0
)
itk_add_test(NAME  BinaryMinMaxCurvatureFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMinMaxCurvatureFlowImageFilter.png}
            ${TEMP}/BinaryMinMaxCurvatureFlowImageFilter.png
  $<TARGET_FILE:BinaryMinMaxCurvatureFlowImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinaryMinMaxCurvatureFlowImageFilter.png
        10 .125 1 128
)
itk_add_test(NAME  BinaryThresholdImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryThresholdImageFilter.png}
            ${TEMP}/BinaryThresholdImageFilter.png
  $<TARGET_FILE:BinaryThresholdImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinaryThresholdImageFilter.png
        150 180 0 255
)
itk_add_test(NAME  BinaryMedianImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter1.png}
            ${TEMP}/BinaryMedianImageFilter1.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter1.png
        1 1
)
itk_add_test(NAME  BinaryMedianImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter2.png}
            ${TEMP}/BinaryMedianImageFilter2.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter2.png
        2 2
)
itk_add_test(NAME  BinaryMedianImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinaryMedianImageFilter3.png}
            ${TEMP}/BinaryMedianImageFilter3.png
  $<TARGET_FILE:BinaryMedianImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/BinaryMedianImageFilter3.png
        3 3
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter1.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter1.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter1.png
        1 1
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter2.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter2.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter2.png
        2 2
)
itk_add_test(NAME  VotingBinaryHoleFillingImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryHoleFillingImageFilter3.png}
            ${TEMP}/VotingBinaryHoleFillingImageFilter3.png
  $<TARGET_FILE:VotingBinaryHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryHoleFillingImageFilter3.png
        3 3
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter1.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter1.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter1.png
        1 1 10
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter2.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter2.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter2.png
        2 2 10
)
itk_add_test(NAME  VotingBinaryIterativeHoleFillingImageFilterTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VotingBinaryIterativeHoleFillingImageFilter3.png}
            ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter3.png
  $<TARGET_FILE:VotingBinaryIterativeHoleFillingImageFilter>
        DATA{${BASELINE}/BinaryThresholdImageFilter.png}
        ${TEMP}/VotingBinaryIterativeHoleFillingImageFilter3.png
        3 3 10
)
itk_add_test(NAME  BinomialBlurImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/BinomialBlurImageFilter.png}
            ${TEMP}/BinomialBlurImageFilter.png
  $<TARGET_FILE:BinomialBlurImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/BinomialBlurImageFilter.png
        5
)
itk_add_test(NAME  CompositeFilterExampleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{Baseline/CompositeFilterExample.mha}
            ${TEMP}/CompositeFilterExample.mha
  $<TARGET_FILE:CompositeFilterExample>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CompositeFilterExample.mha
)
itk_add_test(NAME  CurvatureAnisotropicDiffusionImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/CurvatureAnisotropicDiffusionImageFilter.png}
            ${TEMP}/CurvatureAnisotropicDiffusionImageFilter.png
  $<TARGET_FILE:CurvatureAnisotropicDiffusionImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CurvatureAnisotropicDiffusionImageFilter.png
        5 0.125 3
)
itk_add_test(NAME  CurvatureFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/CurvatureFlowImageFilter.png}
            ${TEMP}/CurvatureFlowImageFilter.png
  $<TARGET_FILE:CurvatureFlowImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/CurvatureFlowImageFilter.png
        5 0.125 1.0
)
itk_add_test(NAME  DanielssonDistanceMapImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DanielssonDistanceMapImageFilter.png}
            ${TEMP}/DanielssonDistanceMapImageFilter.png
  $<TARGET_FILE:DanielssonDistanceMapImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/FivePoints.png
        ${TEMP}/DanielssonDistanceMapImageFilter.png
        ${TEMP}/DanielssonDistanceMapImageFilter2.png
        ${TEMP}/DanielssonDistanceMapImageFilter.mha
)
itk_add_test(NAME  DiscreteGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DiscreteGaussianImageFilter.png}
            ${TEMP}/DiscreteGaussianImageFilter.png
  $<TARGET_FILE:DiscreteGaussianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/DiscreteGaussianImageFilter.png
        1.73 10
)
itk_add_test(NAME  GradientAnisotropicDiffusionImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientAnisotropicDiffusionImageFilter.png}
            ${TEMP}/GradientAnisotropicDiffusionImageFilter.png
  $<TARGET_FILE:GradientAnisotropicDiffusionImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientAnisotropicDiffusionImageFilter.png
        5 0.125 1.0
)
itk_add_test(NAME  GradientMagnitudeImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientMagnitudeImageFilter.png}
            ${TEMP}/GradientMagnitudeImageFilter.png
  $<TARGET_FILE:GradientMagnitudeImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientMagnitudeImageFilter.png
)
itk_add_test(NAME  GradientMagnitudeRecursiveGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GradientMagnitudeRecursiveGaussianImageFilter.png}
            ${TEMP}/GradientMagnitudeRecursiveGaussianImageFilter.png
  $<TARGET_FILE:GradientMagnitudeRecursiveGaussianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GradientMagnitudeRecursiveGaussianImageFilter.png
        5
)
itk_add_test(NAME  GradientRecursiveGaussianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:GradientRecursiveGaussianImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
        ${TEMP}/GradientRecursiveGaussianImageFilterTest.mha
        1.5  # Sigma
)
itk_add_test(NAME  GradientVectorFlowImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:GradientVectorFlowImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/GradientRecursiveGaussianImageFilterTest.mha}
        ${TEMP}/GradientVectorFlowImageFilterTest.mha
        5        # number of iterations
        2000.0   # noise level
)
set_tests_properties( GradientVectorFlowImageFilterTest
  PROPERTIES DEPENDS GradientRecursiveGaussianImageFilterTest)
itk_add_test(NAME  DerivativeImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/DerivativeImageFilter.mha}
            ${TEMP}/DerivativeImageFilter.mha
  $<TARGET_FILE:DerivativeImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/DerivativeImageFilter.mha
        ${TEMP}/DerivativeImageFilter.png
        1 1
)
itk_add_test(NAME  LaplacianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/LaplacianImageFilter.png}
            ${TEMP}/LaplacianImageFilter.png
  $<TARGET_FILE:LaplacianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/LaplacianImageFilter.png
)
itk_add_test(NAME  LaplacianSharpeningImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/LaplacianSharpeningImageFilter.png}
            ${TEMP}/LaplacianSharpeningImageFilter.png
  $<TARGET_FILE:LaplacianSharpeningImageFilter>
        DATA{${ITK_SOURCE_DIR}/Testing/Data/Input/cthead1.png}
        ${TEMP}/LaplacianSharpeningImageFilter.png
)
itk_add_test(NAME  MathematicalMorphologyBinaryFiltersTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MathematicalMorphologyBinaryFiltersErode.png}
            ${TEMP}/MathematicalMorphologyBinaryFiltersErode.png
  $<TARGET_FILE:MathematicalMorphologyBinaryFilters>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MathematicalMorphologyBinaryFiltersErode.png
        ${TEMP}/MathematicalMorphologyBinaryFiltersDilate.png
        150 180
)
itk_add_test(NAME  MathematicalMorphologyGrayscaleFiltersTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MathematicalMorphologyGrayscaleFiltersErode.png}
            ${TEMP}/MathematicalMorphologyGrayscaleFiltersErode.png
  $<TARGET_FILE:MathematicalMorphologyGrayscaleFilters>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MathematicalMorphologyGrayscaleFiltersErode.png
        ${TEMP}/MathematicalMorphologyGrayscaleFiltersDilate.png
)
itk_add_test(NAME  MeanImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MeanImageFilter.png}
            ${TEMP}/MeanImageFilter.png
  $<TARGET_FILE:MeanImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MeanImageFilter.png
)
itk_add_test(NAME  MedianImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/MedianImageFilter.png}
            ${TEMP}/MedianImageFilter.png
  $<TARGET_FILE:MedianImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/MedianImageFilter.png
        1
)
itk_add_test(NAME  ResampleImageFilterTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ResampleImageFilterTest1.png}
            ${TEMP}/ResampleImageFilterTest1.png
  $<TARGET_FILE:ResampleImageFilter>

=== Examples/IO/test/CMakeLists.txt ===
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

if(ITK_WRAP_PYTHON)
  INTERSECTION(WRAP_2 2 "${ITK_WRAP_DIMS}")

  if(ITK_WRAP_signed_short AND ITK_WRAP_unsigned_char AND WRAP_2)
    add_python_test(DicomSliceReadPythonTest
      ${CMAKE_CURRENT_SOURCE_DIR}/../DicomSliceRead.py
      DATA{${ITK_DATA_ROOT}/Input/dicom-sc_cs-1.dcm}
      ${TEMP}/DicomSliceReadPythonOutput.png
      --compare ${TEMP}/DicomSliceReadPythonOutput.png
        DATA{${ITK_SOURCE_DIR}/Examples/IO/test/Baseline/DicomSliceReadPythonOutputBaseline.png}
      )
  endif()
endif(ITK_WRAP_PYTHON)

if(ITK_VISIBLEHUMAN_DATA_ROOT)
  itk_add_test(NAME VisibleHumanStreamReadWriteTest
    COMMAND ${ITK_TEST_DRIVER}
   $<TARGET_FILE:VisibleHumanStreamReadWrite>
    ${ITK_VISIBLEHUMAN_DATA_ROOT}/Male/Fullcolor/fullbody/
    ${TEMP}/VisibleHumanStreamReadWrite.mha )
  itk_add_test(NAME VisibleHumanPasteWriteTest
    COMMAND ${ITK_TEST_DRIVER}
   $<TARGET_FILE:VisibleHumanPasteWrite>
    ${TEMP}/VisibleHumanStreamReadWrite.mha
    ${TEMP}/VisibleHumanPasteWrite.mha)
  # this test must be run sequentially, be cause the output of the first is used by the second
  set_tests_properties(
    VisibleHumanStreamReadWriteTest
    PROPERTIES
    RUN_SERIAL 1
    )
  set_tests_properties(
    VisibleHumanPasteWriteTest
    PROPERTIES
    DEPENDS VisibleHumanStreamReadWriteTest
    )
endif(ITK_VISIBLEHUMAN_DATA_ROOT)

=== Examples/Segmentation/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Segmentation)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

itk_add_test(NAME ConfidenceConnectedWhiteTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConfidenceConnectedWhiteTest.png}
            ${TEMP}/ConfidenceConnectedWhiteTest.png
  $<TARGET_FILE:ConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConfidenceConnectedWhiteTest.png
        60 116
)

itk_add_test(NAME ConfidenceConnectedVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConfidenceConnectedVentricleTest.png}
            ${TEMP}/ConfidenceConnectedVentricleTest.png
  $<TARGET_FILE:ConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConfidenceConnectedVentricleTest.png
        81 112
)

itk_add_test(NAME ConfidenceConnectedGrayTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConfidenceConnectedGrayTest.png}
            ${TEMP}/ConfidenceConnectedGrayTest.png
  $<TARGET_FILE:ConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConfidenceConnectedGrayTest.png
        107 69
)

itk_add_test(NAME ConnectedThresholdWhiteTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConnectedThresholdWhiteTest.png}
            ${TEMP}/ConnectedThresholdWhiteTest.png
  $<TARGET_FILE:ConnectedThresholdImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConnectedThresholdWhiteTest.png
        60 116 150 180
)

itk_add_test(NAME ConnectedThresholdVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConnectedThresholdVentricleTest.png}
            ${TEMP}/ConnectedThresholdVentricleTest.png
  $<TARGET_FILE:ConnectedThresholdImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConnectedThresholdVentricleTest.png
        81 112 210 250
)

itk_add_test(NAME ConnectedThresholdGrayTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ConnectedThresholdGrayTest.png}
            ${TEMP}/ConnectedThresholdGrayTest.png
  $<TARGET_FILE:ConnectedThresholdImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ConnectedThresholdGrayTest.png
        107 69 180 210
)

itk_add_test(NAME FastMarchingLeftVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/FastMarchingLeftVentricleTest.png}
            ${TEMP}/FastMarchingLeftVentricleTest.png
  $<TARGET_FILE:FastMarchingImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/FastMarchingLeftVentricleTest.png
        81 114 1.0 -0.5 3.0 100 100
)

itk_add_test(NAME FastMarchingRightVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/FastMarchingRightVentricleTest.png}
            ${TEMP}/FastMarchingRightVentricleTest.png
  $<TARGET_FILE:FastMarchingImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/FastMarchingRightVentricleTest.png
        99 114 1.0 -0.5 3.0 100 100
)

itk_add_test(NAME FastMarchingWhiteMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/FastMarchingWhiteMatterTest.png}
            ${TEMP}/FastMarchingWhiteMatterTest.png
  $<TARGET_FILE:FastMarchingImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/FastMarchingWhiteMatterTest.png
        56 92 1.0 -0.3 2.0 200 100
)

itk_add_test(NAME FastMarchingGrayMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/FastMarchingGrayMatterTest.png}
            ${TEMP}/FastMarchingGrayMatterTest.png
  $<TARGET_FILE:FastMarchingImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/FastMarchingGrayMatterTest.png
        40 90 .5 -0.3 2.0 200 100
)

itk_add_test(NAME GeodesicActiveContourLeftVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GeodesicActiveContourLeftVentricleTest.png}
            ${TEMP}/GeodesicActiveContourLeftVentricleTest.png
  $<TARGET_FILE:GeodesicActiveContourImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GeodesicActiveContourLeftVentricleTest.png
        81 114 5.0 1.0 -0.5 3.0 2.0
)

itk_add_test(NAME GeodesicActiveContourRightVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GeodesicActiveContourRightVentricleTest.png}
            ${TEMP}/GeodesicActiveContourRightVentricleTest.png
  $<TARGET_FILE:GeodesicActiveContourImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GeodesicActiveContourRightVentricleTest.png
        99 114 5.0 1.0 -0.5 3.0 2.0
)

itk_add_test(NAME GeodesicActiveContourWhiteMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GeodesicActiveContourWhiteMatterTest.png}
            ${TEMP}/GeodesicActiveContourWhiteMatterTest.png
  $<TARGET_FILE:GeodesicActiveContourImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GeodesicActiveContourWhiteMatterTest.png
        56 92 5.0 1.0 -0.3 2.0 10.0
)

itk_add_test(NAME GeodesicActiveContourGrayMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GeodesicActiveContourGrayMatterTest.png}
            ${TEMP}/GeodesicActiveContourGrayMatterTest.png
  $<TARGET_FILE:GeodesicActiveContourImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/GeodesicActiveContourGrayMatterTest.png
        40 90 5.0 .5 -0.3 2.0 10.0
)

itk_add_test(NAME ShapeDetectionLevelSetLeftVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ShapeDetectionLevelSetLeftVentricleTest.png}
            ${TEMP}/ShapeDetectionLevelSetLeftVentricleTest.png
  $<TARGET_FILE:ShapeDetectionLevelSetFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ShapeDetectionLevelSetLeftVentricleTest.png
        81 114 5.0 1.0 -0.5 3.0 0.05 1.0
)

itk_add_test(NAME ShapeDetectionLevelSetRightVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ShapeDetectionLevelSetRightVentricleTest.png}
            ${TEMP}/ShapeDetectionLevelSetRightVentricleTest.png
  $<TARGET_FILE:ShapeDetectionLevelSetFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ShapeDetectionLevelSetRightVentricleTest.png
        99 114 5.0 1.0 -0.5 3.0 0.05 1.0
)

itk_add_test(NAME ShapeDetectionLevelSetWhiteMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ShapeDetectionLevelSetWhiteMatterTest.png}
            ${TEMP}/ShapeDetectionLevelSetWhiteMatterTest.png
  $<TARGET_FILE:ShapeDetectionLevelSetFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ShapeDetectionLevelSetWhiteMatterTest.png
        56 92 5.0 1.0 -0.3 2.0 0.05 1.0
)

itk_add_test(NAME ShapeDetectionLevelSetGrayMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ShapeDetectionLevelSetGrayMatterTest.png}
            ${TEMP}/ShapeDetectionLevelSetGrayMatterTest.png
  $<TARGET_FILE:ShapeDetectionLevelSetFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ShapeDetectionLevelSetGrayMatterTest.png
        40 90 5.0 1.0 -0.3 2.0 0.05 1.0
)

itk_add_test(NAME ThresholdSegmentationLevelSetVentricleTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ThresholdSegmentationLevelSetVentricleTest.png}
            ${TEMP}/ThresholdSegmentationLevelSetVentricleTest.png
  $<TARGET_FILE:ThresholdSegmentationLevelSetImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ThresholdSegmentationLevelSetVentricleTest.png
        81 112 5 210 250
)

itk_add_test(NAME ThresholdSegmentationLevelSetWhiteMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ThresholdSegmentationLevelSetWhiteMatterTest.png}
            ${TEMP}/ThresholdSegmentationLevelSetWhiteMatterTest.png
  --compareNumberOfPixelsTolerance 40
  $<TARGET_FILE:ThresholdSegmentationLevelSetImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ThresholdSegmentationLevelSetWhiteMatterTest.png
        60 116 5 150 180
)

itk_add_test(NAME ThresholdSegmentationLevelSetGrayMatterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/ThresholdSegmentationLevelSetGrayMatterTest.png}
            ${TEMP}/ThresholdSegmentationLevelSetGrayMatterTest.png
  $<TARGET_FILE:ThresholdSegmentationLevelSetImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/ThresholdSegmentationLevelSetGrayMatterTest.png
        107 69 5 180 210
)

itk_add_test(NAME CellularSegmentation1Test COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:CellularSegmentation1>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        100 115 200 255 3000
        ${TEMP}/CellularSegmentation1Test.vtk
)

if( ITK_USE_BRAINWEB_DATA )

itk_add_test(NAME CellularSegmentation2Test COMMAND ${ITK_TEST_DRIVER}
  $<TARGET_FILE:CellularSegmentation2>
        DATA{../../Data/BrainWeb/brainweb1e1a10f20.mha}
        81 113 96 220 255 2000
        ${TEMP}/CellularSegmentation2Test.vtk
)

endif( ITK_USE_BRAINWEB_DATA )

itk_add_test(NAME VectorConfidenceConnectedTest1 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VectorConfidenceConnected1.png}
            ${TEMP}/VectorConfidenceConnected1.png
  $<TARGET_FILE:VectorConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/VisibleWomanEyeSlice.png
        ${TEMP}/VectorConfidenceConnected1.png
        70 120 7 1
)

itk_add_test(NAME VectorConfidenceConnectedTest2 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VectorConfidenceConnected2.png}
            ${TEMP}/VectorConfidenceConnected2.png
  $<TARGET_FILE:VectorConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/VisibleWomanEyeSlice.png
        ${TEMP}/VectorConfidenceConnected2.png
        23 93 7 1
)

itk_add_test(NAME VectorConfidenceConnectedTest3 COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/VectorConfidenceConnected3.png}
            ${TEMP}/VectorConfidenceConnected3.png
  $<TARGET_FILE:VectorConfidenceConnected>
        ${ITK_SOURCE_DIR}/Examples/Data/VisibleWomanEyeSlice.png
        ${TEMP}/VectorConfidenceConnected3.png
        66 66 3 1
)


itk_add_test(NAME CannySegmentationLevelSetImageFilterTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/CannySegmentationLevelSetImageFilterTest.png}
            ${TEMP}/CannySegmentationLevelSetImageFilterTest.png
  $<TARGET_FILE:CannySegmentationLevelSetImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        DATA{${BASELINE}/ThresholdSegmentationLevelSetVentricle.png}
        ${TEMP}/CannySegmentationLevelSetImageFilterTest.png
        7 0.1 -10.0 127.5 10000
)

itk_add_test(NAME GeodesicActiveContourShapePriorCallosumTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/GeodesicActiveContourShapePriorCallosumTest.png}
            ${TEMP}/GeodesicActiveContourShapePriorCallosumTest.png
  $<TARGET_FILE:GeodesicActiveContourShapePriorLevelSetImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainMidSagittalSlice.png
        ${TEMP}/GeodesicActiveContourShapePriorCallosumTest.png
        120 85 60 102 88 83 6 1.0 0.5 0.02
        ${ITK_SOURCE_DIR}/Examples/Data/CorpusCallosumMeanShape.mha 3
        ${ITK_SOURCE_DIR}/Examples/Data/CorpusCallosumMode%d.mha 10 0
)

itk_add_test(NAME NeighborhoodConnectedWhiteTest COMMAND ${ITK_TEST_DRIVER}
  --compare DATA{${BASELINE}/NeighborhoodConnectedWhiteTest.png}
            ${TEMP}/NeighborhoodConnectedWhiteTest.png
  $<TARGET_FILE:NeighborhoodConnectedImageFilter>
        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
        ${TEMP}/NeighborhoodConnectedWhiteTest.png
        60 116 150 180
)

=== debian/changelog ===
insighttoolkit4 (4.2.1-2) unstable; urgency=low

  * patches/DRtest-1.diff:
  * patches/DRtest-2.diff: New.  Fixes DigitallyReconstructedRadiograph
    generation on i386.
  
  * patches/bsd-hdf5.patch: New.  Workaround for #686402.

 -- Steve M. Robbins <smr@debian.org>  Sat, 27 Oct 2012 09:15:12 -0500

insighttoolkit4 (4.2.1-1) unstable; urgency=low

  * New upstream version.
  
  * rules: Disable FFTW, due to test failures (in v4.2.0).

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Oct 2012 23:07:09 -0500

insighttoolkit4 (4.2.0-1) unstable; urgency=low

  * New upstream version.
    - build with gcc 4.7.
    - set ITK_USE_REVIEW = ON.
    - upstream tarball no longer contains directories that must be 
      deleted; remove target get-orig-source.
  
  * patches/gcc4.7.patch:
  * patches/tiff-big-endian.patch: Removed.  Applied upstream.

 -- Steve M. Robbins <steve@sumost.ca>  Sat, 25 Aug 2012 00:14:06 -0500

insighttoolkit4 (4.1.0-2) experimental; urgency=low

  * control.in: Dev package conflicts with libinsighttoolkit3-dev.
    Closes: #670609.
  
  * patches/tiff-big-endian.patch: New.  Fix build failure on big-endian
    machines.

  * patches/gcc4.7.patch: New.  Fixes for gcc 4.7 issues.
  
  * rules: Do not use system fftw.  

  * control.in:
  * rules: Build using gcc 4.6.

 -- Steve M. Robbins <smr@debian.org>  Sat, 09 Jun 2012 23:12:22 -0500

=== debian/control ===
Source: insighttoolkit4
Homepage: http://www.itk.org/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Steve M. Robbins <smr@debian.org>, Mathieu Malaterre <mathieu.malaterre@gmail.com>
Build-Depends: debhelper (>= 8),
 cmake, cableswig (>= 0.1.0+cvs20110226), gccxml (>= 0.9.0+cvs20110723),
 zlib1g-dev (>= 1.2.2), libpng12-dev, libvxl1-dev,
 libfftw3-dev,
 uuid-dev, libgdcm2-dev, libminc-dev, libhdf5-dev,
 libvtk5-dev, python-vtk
Standards-Version: 3.9.2
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/insighttoolkit/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/insighttoolkit/trunk/

Package: libinsighttoolkit4.2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit4-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libinsighttoolkit4.2 (= ${binary:Version}), libgdcm2-dev
Recommends: libfftw3-dev, uuid-dev
Conflicts: libinsighttoolkit-dev, libinsighttoolkit3-dev
Replaces: libinsighttoolkit-dev
Suggests: insighttoolkit4-examples
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit4-examples
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libinsighttoolkit4-dev
Conflicts: insighttoolkit-examples
Replaces: insighttoolkit-examples
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

VER_MAJOR = 4
VER_MINOR = 2
VER_PATCH = 1

# TODO: turn on the following:
#
# system HDF5 (omits C++ bindings; Bug #660547)
# system TIFF (requires version 4, but libvtk5-dev depends on version 3)
# system FFTW (test failures; see http://lists.debian.org/debian-med/2012/04/msg00064.html)
# system VXL (Bug #656837)
# Module_ITKLevelSetsv4Visualization (https://issues.itk.org/jira/browse/ITK-2856)
# Module_ITKVideoBridgeOpenCV (undiagnosed build error)
# Module_ITKVideoBridgeVXL (undiagnosed build error)
# Module_ITKVtkGlue (https://issues.itk.org/jira/browse/ITK-2856)

CMAKE_FLAGS = \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DCMAKE_EXPORT_COMPILE_COMMANDS:BOOL=ON \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DITKV3_COMPATIBILITY:BOOL=ON \
	-DITK_USE_MINC2:BOOL=ON \
	-DITK_USE_REVIEW:BOOL=ON \
	-DITK_USE_STRICT_CONCEPT_CHECKING:BOOL=ON \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_HDF5:BOOL=OFF \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=OFF \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DModule_ITKIOPhilipsREC:BOOL=ON \
	-DModule_ITKLevelSetsv4Visualization:BOOL=OFF \
	-DModule_ITKVideoBridgeOpenCV:BOOL=OFF \
	-DModule_ITKVideoBridgeVXL:BOOL=OFF \
	-DModule_ITKVtkGlue:BOOL=OFF \
	-DUSE_FFTWD:BOOL=OFF \
	-DUSE_FFTWF:BOOL=OFF \
	-DUSE_SYSTEM_FFTW:BOOL=OFF \
	-DVCL_INCLUDE_CXX_0X:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON

VER_FULL = $(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)
SOVERSION = $(VER_MAJOR).$(VER_MINOR)

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_examples = insighttoolkit$(VER_MAJOR)-examples


%:
	dh $@ --builddir=BUILD --parallel

override_dh_auto_configure: pre-build
	dh_auto_configure -- $(CMAKE_FLAGS)

pre-build:
	echo "Available disk space:"
	df -h .

override_dh_auto_test:
	LD_LIBRARY_PATH=`pwd`/BUILD/lib dh_auto_test

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitktiff-4.2.so.1: tiff" >> debian/$(pkg_lib).lintian-overrides
	dh_lintian

override_dh_install: 
	# pkg_lib
	dh_install -p$(pkg_lib) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so.* usr/lib
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
	cp Modules/ThirdParty/VNL/src/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind
	#
	# pkg_dev
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_installdocs -p$(pkg_dev) Documentation/*
	dh_install -p$(pkg_dev) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so usr/lib
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/ITK-$(SOVERSION)/*
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/cmake
#	dh_install -p$(pkg_dev) Wrapping/WrapITK /usr/src

override_dh_installexamples:
	# pkg_examples
	dh_installexamples -p$(pkg_examples) Examples/*
ifneq (,$(filter $(pkg_examples), $(shell dh_listpackages)))
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644
endif

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control
